/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the DestinationFieldResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DestinationFieldResponseInner{}

// DestinationFieldResponseInner struct for DestinationFieldResponseInner
type DestinationFieldResponseInner struct {
	Label    *string `json:"label,omitempty"`
	Value    *string `json:"value,omitempty"`
	Type     *string `json:"type,omitempty"`
	Unique   *bool   `json:"unique,omitempty"`
	Required *bool   `json:"required,omitempty"`
}

// NewDestinationFieldResponseInner instantiates a new DestinationFieldResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDestinationFieldResponseInner() *DestinationFieldResponseInner {
	this := DestinationFieldResponseInner{}
	return &this
}

// NewDestinationFieldResponseInnerWithDefaults instantiates a new DestinationFieldResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDestinationFieldResponseInnerWithDefaults() *DestinationFieldResponseInner {
	this := DestinationFieldResponseInner{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *DestinationFieldResponseInner) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DestinationFieldResponseInner) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *DestinationFieldResponseInner) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *DestinationFieldResponseInner) SetLabel(v string) {
	o.Label = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *DestinationFieldResponseInner) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DestinationFieldResponseInner) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *DestinationFieldResponseInner) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *DestinationFieldResponseInner) SetValue(v string) {
	o.Value = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *DestinationFieldResponseInner) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DestinationFieldResponseInner) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *DestinationFieldResponseInner) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *DestinationFieldResponseInner) SetType(v string) {
	o.Type = &v
}

// GetUnique returns the Unique field value if set, zero value otherwise.
func (o *DestinationFieldResponseInner) GetUnique() bool {
	if o == nil || IsNil(o.Unique) {
		var ret bool
		return ret
	}
	return *o.Unique
}

// GetUniqueOk returns a tuple with the Unique field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DestinationFieldResponseInner) GetUniqueOk() (*bool, bool) {
	if o == nil || IsNil(o.Unique) {
		return nil, false
	}
	return o.Unique, true
}

// HasUnique returns a boolean if a field has been set.
func (o *DestinationFieldResponseInner) HasUnique() bool {
	if o != nil && !IsNil(o.Unique) {
		return true
	}

	return false
}

// SetUnique gets a reference to the given bool and assigns it to the Unique field.
func (o *DestinationFieldResponseInner) SetUnique(v bool) {
	o.Unique = &v
}

// GetRequired returns the Required field value if set, zero value otherwise.
func (o *DestinationFieldResponseInner) GetRequired() bool {
	if o == nil || IsNil(o.Required) {
		var ret bool
		return ret
	}
	return *o.Required
}

// GetRequiredOk returns a tuple with the Required field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DestinationFieldResponseInner) GetRequiredOk() (*bool, bool) {
	if o == nil || IsNil(o.Required) {
		return nil, false
	}
	return o.Required, true
}

// HasRequired returns a boolean if a field has been set.
func (o *DestinationFieldResponseInner) HasRequired() bool {
	if o != nil && !IsNil(o.Required) {
		return true
	}

	return false
}

// SetRequired gets a reference to the given bool and assigns it to the Required field.
func (o *DestinationFieldResponseInner) SetRequired(v bool) {
	o.Required = &v
}

func (o DestinationFieldResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DestinationFieldResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Unique) {
		toSerialize["unique"] = o.Unique
	}
	if !IsNil(o.Required) {
		toSerialize["required"] = o.Required
	}
	return toSerialize, nil
}

type NullableDestinationFieldResponseInner struct {
	value *DestinationFieldResponseInner
	isSet bool
}

func (v NullableDestinationFieldResponseInner) Get() *DestinationFieldResponseInner {
	return v.value
}

func (v *NullableDestinationFieldResponseInner) Set(val *DestinationFieldResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableDestinationFieldResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableDestinationFieldResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDestinationFieldResponseInner(val *DestinationFieldResponseInner) *NullableDestinationFieldResponseInner {
	return &NullableDestinationFieldResponseInner{value: val, isSet: true}
}

func (v NullableDestinationFieldResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDestinationFieldResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
